Attribute VB_Name = "APIStuff"
Option Explicit

Public OldWindowProc As Long

Declare Function CallWindowProc Lib "user32" Alias "CallWindowProcA" (ByVal lpPrevWndFunc As Long, ByVal hwnd As Long, ByVal msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long

Public Const GWL_WNDPROC = (-4)

' The last control to have focus.
Public gFocusControl As String

' Process Windows messages.
Public Function NewWindowProc(ByVal hwnd As Long, ByVal msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Const WM_SETCURSOR = &H20

    ' See if this is a WM_SETCURSOR message.
    If msg = WM_SETCURSOR Then
        ' See if the message is for a button.
        If wParam = Form1.Command1.hwnd Or _
           wParam = Form1.Command2.hwnd _
        Then
            ' It is a button. See if the active
            ' control is not a button. Don't save
            ' the name of a button (in case the
            ' user clicks a button twice).
            If Not (TypeOf Screen.ActiveControl Is CommandButton) Then
                gFocusControl = Screen.ActiveControl.Name
            End If
        End If
    End If

    ' Process the message normally.
    NewWindowProc = CallWindowProc( _
        OldWindowProc, hwnd, msg, wParam, _
        lParam)
End Function
